/*
================================================================================
 File: crc16.h
--------------------------------------------------------------------------------
 Author:        Piotr Wojtowicz
 Purpose:       CRC16 library
 Compiler:      ANSI C
 Hardware:      
 Doc:
--------------------------------------------------------------------------------
 Includes:      
--------------------------------------------------------------------------------
 Comments:      used to calculate CRC16 checksums
                          UWAGA!!!
                Oprogramowanie to udostępnione jest do celów poglądowych,
                nie jest przetestowane pod kątem bezpieczeństwa ani spełnienia
                jakichkolwiek norm wymaganych aby urządzenie używające go
                mogło być dopuszczone do użytku, dlatego używasz go
                na własną odpowiedzialność a jego autor nie ponosi żadnego
                typu odpowiedzialności za jakiekolwiek skutki jego użycia.
                Jeżeli nie zgadzasz się z powyższym warunkiem proszę
                o nieużywanie tego oprogramowania.
================================================================================
*/

#ifndef CRC16_H
#define CRC16_H
#include <stdint.h>

// if 0 - minimum size of library
// if 1 - maximum speed
#define CRC16_LIB_MAX_SPEED_SUPPORT		0

// max speed mode
#if(CRC16_LIB_MAX_SPEED_SUPPORT == 1)

extern const uint16_t CRC16_both_table[256];

#define crc16(crc, byte) ((uint16_t)(CRC16_both_table[(uint8_t)(byte)] ^ CRC16_both_table[(uint8_t)((crc) >> 8)] ^ ((((uint16_t)(crc)) << 8) & 0xFF00)))

// minimum size mode
#else

uint16_t crc16(uint16_t crc, uint8_t data);

#endif

#endif // CRC16_H
