/*
================================================================================
 File: crc7.h
--------------------------------------------------------------------------------
 Author:        Piotr Wojtowicz
 Purpose:       CRC7 library
 Compiler:      ANSI C
 Hardware:      
 Doc:
--------------------------------------------------------------------------------
 Includes:      
--------------------------------------------------------------------------------
 Comments:      used to calculate CRC7 checksums
                          UWAGA!!!
                Oprogramowanie to udostępnione jest do celów poglądowych,
                nie jest przetestowane pod kątem bezpieczeństwa ani spełnienia
                jakichkolwiek norm wymaganych aby urządzenie używające go
                mogło być dopuszczone do użytku, dlatego używasz go
                na własną odpowiedzialność a jego autor nie ponosi żadnego
                typu odpowiedzialności za jakiekolwiek skutki jego użycia.
                Jeżeli nie zgadzasz się z powyższym warunkiem proszę
                o nieużywanie tego oprogramowania.
================================================================================
*/

#ifndef CRC7_H_
#define CRC7_H_
#include <stdint.h>

// if 0 - minimum size of library
// if 1 - maximum speed
#define CRC7_LIB_MAX_SPEED_SUPPORT		0

// max speed mode
#if(CRC7_LIB_MAX_SPEED_SUPPORT == 1)

extern const uint8_t crc7_data_table[256];
extern const uint8_t crc7_crc_table[128];

#define crc7(crc, data) ((uint8_t)(crc7_data_table[(data)] ^ crc7_crc_table[(crc)]))

// minimum size mode
#else

uint8_t crc7(uint8_t crc, uint8_t data);

#endif


#endif /*CRC7_H_*/
