/*
================================================================================
 File: sd_spi.h
--------------------------------------------------------------------------------
 Author:        Piotr Wojtowicz
 Purpose:       SD library uses SPI interface MSM compatible
 Compiler:      ANSI C
 Hardware:      
 Doc:
--------------------------------------------------------------------------------
 Includes:      
--------------------------------------------------------------------------------
 Comments:                      UWAGA!!!
                Oprogramowanie to udostępnione jest do celów poglądowych,
                nie jest przetestowane pod kątem bezpieczeństwa ani spełnienia
                jakichkolwiek norm wymaganych aby urządzenie używające go
                mogło być dopuszczone do użytku, dlatego używasz go
                na własną odpowiedzialność a jego autor nie ponosi żadnego
                typu odpowiedzialności za jakiekolwiek skutki jego użycia.
                Jeżeli nie zgadzasz się z powyższym warunkiem proszę
                o nieużywanie tego oprogramowania.
================================================================================
*/

#ifndef SD_SPI_H_
#define SD_SPI_H_
#include <stdint.h>


#include "stm32f10x_spi.h"
#include "stm32f10x_gpio.h"

#include "msm.h"


#define SD_MINIMUM_SIZE_SUPPORT		1


#define R0_IN_IDLE_STATE			0x01
#define R0_ERASE_RESET				0x02
#define R0_ILLEGAL_COMMAND			0x04
#define R0_COM_CRC_ERROR			0x08
#define R0_ERASE_SEQUENCE_ERROR		0x10
#define R0_ADRESS_ERROR				0x20
#define R0_PARAMETER_ERROR			0x40



typedef struct {
	MSMD_Desc SD_Desc;
	MSMD_AccessParameters SD_Parameters;
	uint8_t SD_Descriptor[9];
	SPI_TypeDef *SD_SPI;
	GPIO_TypeDef* GPIO_NSS;
	uint16_t GPIO_Pin_NSS;
}SD_SPI_MSD;



void SD_SPI_init(SD_SPI_MSD *SD, SPI_TypeDef *SD_SPI, GPIO_TypeDef* GPIO_NSS, uint16_t GPIO_Pin_NSS);


#endif /*SD_SPI_H_*/
